/*------------------------------------------------------------------------------
 lib/djv_image/_gl_data.h

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "gl_data.h"

namespace djv {
namespace image {
namespace gl {
namespace data {

class Data::_Texture {
public:
  
  _Texture();
  ~_Texture();
    
  void set(const image::Data *);
  void draw(const Options &) throw (Error);
  
private:

  FILTER _filter;
  const image::Data * _data;
  image::data::Info _info;
  bool _init;
  GLuint _texture;
  bool _texture_init;
  Vec2i _texture_size;
};

class Data::_Fixed {
public:
  
  void draw(const Options &) throw (Error);
};

class Data::_Shader {
public:
  
  _Shader();
  ~_Shader();
  
  void draw(const Options &) throw (Error);
  
private:

  profile::PROFILE _profile;
  Display _display;
  CHANNEL _channel;
  bool _init;
  GLuint _profile_lut, _display_lut;
  GLhandleARB _shader, _program;
};

}
}
}
}
