/*------------------------------------------------------------------------------
 lib/djv_image/tag.h

 Image Tags
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_IMAGE_TAG_H
#define DJV_IMAGE_TAG_H

#include <djv_image/base.h>

namespace djv {
namespace image {
namespace tag {

enum TAG {
  PROJECT, CREATOR, DESCRIPTION, COPYRIGHT,
  TIME, UTC_OFFSET,
  KEYCODE, TIMECODE
};

class Tag {
public:
  
  void add(const Tag &);
  void add(const Str & key, const Str & value);
  Str & operator [] (const Str & key);
  
  Str get(const Str & key) const;
  Str operator [] (const Str & key) const { return get(key); }
  List<Str> key_list() const;
  
  bool valid(const Str & key);
  
  void del();
  
private:

  typedef std::pair<Str, Str> Pair;
  
  List<Pair> _list;
};

// Labels.

const List<Str> & label();

}
}
}

#endif
