/*------------------------------------------------------------------------------
 lib/djv_ui/app.h
 
 User Interface Application

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_APP_H
#define DJV_UI_APP_H

#include <djv_image/app.h>
#include <djv_ui/base.h>

namespace djv {
namespace ui {
namespace app {

class App : public djv::image::app::App, public Callback_Base {
public:

  App(const Str & name, int & argc, char ** argv) throw (Error);
  virtual ~App();
  
  // Execution.

  virtual int exec();
  virtual void exit();
  virtual void valid(bool);
  bool valid() const { return _valid; }
  
  // Information.

  virtual Str info() const;
  
  // Messages.

  virtual void message(const Str &) const;
  virtual void error(const Str &) const;
  virtual void error(const Error &) const;

  // XXX

  void widget_add(widget::Base *);
  void widget_del(widget::Base *);
  void window_add(window::Widget *);
  void window_del(window::Widget *);
  void window_update();
  void window_redraw();

private:

  bool _valid;
  List<widget::Base *> _widget_list;
  List<window::Widget *> _window_list;
};

// Global.

App * app();

}
}
}

#endif

