/*------------------------------------------------------------------------------
 lib/djv_ui/color_swatch.cxx

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "color.h"
#include <djv_ui/style.h>
#include <FL/fl_draw.H>

namespace djv {
namespace ui {
namespace color {

Swatch::Swatch()
{
  frame(FL_THIN_DOWN_BOX);
}

void Swatch::set(const djv::image::Color & in)
{
  if (in == _value) return;
  _value = in;
  redraw();
  sig.emit(_value);
}

void Swatch::dirty()
{
  Frame::dirty();
  
  _size_hint = Vec2i(style::style()->swatch_size()) + frame_size() * 2;
}

void Swatch::draw()
{
  Frame::draw();

  const Box2i geom = frame_geom();

  djv::image::Color tmp(djv::image::pixel::RGB_U8);
  djv::image::color::convert(_value, &tmp);
  fl_color(tmp.get_u8(0), tmp.get_u8(1), tmp.get_u8(2));
  fl_rectf(geom.x, geom.y, geom.w, geom.h);
}

}
}
}
