/*------------------------------------------------------------------------------
 lib/djv_ui/pixel.cxx
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#include "pixel.h"
#include <djv_ui/layout_row.h>
#include <djv_ui/choice.h>

namespace djv {
namespace ui {
namespace pixel {

Widget::Widget() :
  _value(djv::image::pixel::PIXEL(0))
{
  _widget = new choice::Widget(djv::image::pixel::pixel_label());
  add(_widget);
  
  size_policy(FIXED, FIXED);
  align_policy(LEFT, CENTER);
  
  widget_update();
  
  _widget->sig.set(this, widget_callback);
}

void Widget::set(djv::image::pixel::PIXEL in)
{
  if (in == _value) return;
  _value = in;
  widget_update();
  sig.emit(_value);
}

void Widget::widget_del()
{
  _widget->widget_del();
  widget::Widget::widget_del();
}

void Widget::dirty()
{
  widget::Widget::dirty();
  _widget->dirty();
  _size_hint = _widget->size_hint();
}

void Widget::resize(int x, int y, int w, int h)
{
  widget::Widget::resize(x, y, w, h);
  _widget->resize(x, y, w, h);
}

void Widget::widget_callback(int in)
{
  set(djv::image::pixel::PIXEL(in));
}

void Widget::widget_update()
{
  callbacks(false);
  _widget->set(_value);
  callbacks(true);
}

}
}
}
