/*------------------------------------------------------------------------------
 lib/djv_ui/pixel.h
 
 Pixel Widget
 
 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_PIXEL_H
#define DJV_UI_PIXEL_H

#include <djv_image/pixel.h>
#include <djv_ui/widget.h>

namespace djv {
namespace ui {
namespace pixel {

class Widget : public widget::Widget {
public:

  Widget();
  virtual ~Widget() {}

  // Value.
  
  void set(djv::image::pixel::PIXEL);
  djv::image::pixel::PIXEL get() const { return _value; }
  Signal<djv::image::pixel::PIXEL> sig;
  
  // Widget.
  
  virtual void widget_del();
  
  // Layout.
  
  virtual void dirty();
  virtual void resize(int, int, int, int);
  virtual Vec2i size_hint() const { return _size_hint; }
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::pixel::Widget"; }
  
private:

  DJV_CALLBACK(Widget, widget_callback, int);
  
  void widget_update();

  djv::image::pixel::PIXEL _value;
  Vec2i _size_hint;
  choice::Widget * _widget;
};

}
}
}

#endif
