/*------------------------------------------------------------------------------
 lib/djv_ui/scroll.h
 
 Scroll Widget

 Copyright (c) 2004-2007 Darby Johnston. All rights reserved.
 Use is subject to license terms.
------------------------------------------------------------------------------*/

#ifndef DJV_UI_SCROLL_H
#define DJV_UI_SCROLL_H

#include <djv_ui/widget.h>
#include <FL/Fl_Scroll.H>

class Fl_Box;

namespace djv {
namespace ui {
namespace scroll {

class Widget : public Fl_Scroll, public widget::Base {
public:

  Widget();
  virtual ~Widget() {}
  
  // Widget.
  
  virtual int handle(int);
  virtual void draw();
  
  // Layout.

  void resizable(bool);
  bool resizable() const { return _resizable; }

  virtual void update();
  virtual void dirty();
  virtual void resize(int, int, int, int);
  virtual Vec2i size_hint() const { return _size_hint; }
  virtual Vec2i size_min() const { return _size_min; }
  virtual int visible() const { return Fl_Scroll::visible(); }
  
  // Debugging.
  
  virtual Str dbg_name() const { return "djv::ui::scroll::Widget"; }

private:

  bool _resizable;
  Vec2i _size_hint, _size_min;
  Fl_Box * _dummy_widget;
};

}
}
}

#endif
