//#define DJ_DBG

#include <djv_base/user.h>
#include <djv_base/sys.h>
#include <djv_base/file.h>
#include <djv_base/dir.h>
#include <djv_base/app.h>

using namespace djv;

class App : public app::App {
public:
  App(int & argc, char ** argv);
};

App::App(int & argc, char ** argv) :
  app::App("dir", argc, argv)
{
  if (argc != 1 && argc != 2) {
    print("Usage: dir [path]");
    exit(1);
    return;
  }

do {

  Dir dir(2 == argc ? argv[1] : ".");
  List<File> list = dir.list();
  file::seq_compress(&list);
  file::filter(&list, file::FILTER_HIDDEN);
  file::sort(&list, file::SORT_TIME, true);
  list = file::sort_dirs(list);
  
  const int terminal_width = sys::terminal_width();

  for (uint i = 0; i < list.size(); ++i) {

    const Str file = list[i].get(-1, false);
    
    const Str info_str = str::Format("%1 %2 %3 %4 %5").
      arg(file::size_label(list[i].size)).
      arg(user::uid_to_str(list[i].user)).
      arg(file::type_label()[list[i].type], 4).
      arg(file::perm_label(list[i].perm), 3).
      arg(djv::time::time_to_str(list[i].time));
    
    print(
      str::Format("%1 %2").
      arg(file).
      arg(info_str, terminal_width - int(file.size()) - 2));
  }

} while (0);
}

int main(int argc, char ** argv) { return App(argc, argv).exec(); }

