//#define DJV_DBG

#include <djv_ui/layout_row.h>
#include <djv_ui/window.h>
#include <djv_ui/button.h>
#include <djv_ui/app.h>

using namespace djv;

class App : public ui::app::App {
public:

  App(int & argc, char ** argv);
  ~App();

private:

  DJV_CALLBACK(App, push_callback, bool) { print("push button"); }
  DJV_CALLBACK(App, push_callback2, bool) { print("push button 2"); }
  DJV_CALLBACK(App, exit_callback, bool) { exit(); }

  ui::window::Widget * _window;
};

App::App(int & argc, char ** argv) :
  ui::app::App("button", argc, argv),
  _window(0)
{
  DJV_DBG_OBJ("App::App");
  
  ui::button::Push * push_button = new ui::button::Push("Push Button");
  ui::button::Push * push_button2 = new ui::button::Push("Push Button 2");
  _window = new ui::window::Widget(name());

  ui::layout::Vertical * layout = new ui::layout::Vertical(_window);
  layout->add(push_button);
  layout->add(push_button2);
  
  _window->size(_window->size_hint());
  _window->show();

  push_button->sig.set(this, push_callback);
  push_button2->sig.set(this, push_callback2);
  _window->close_sig.set(this, exit_callback);

  valid(true);
}

App::~App()
{
  if (_window) _window->widget_del();
}

int main(int argc, char ** argv)
{
  return App(argc, argv).exec();
}
